﻿import com.delfiweb.error.*;
/*
@class com.delfiweb.error.DError
@author Cédric Néhémie
@version 1.1
@description une classe d'erreur
*/
class com.delfiweb.error.DError extends Error implements _DelfiwebError
{
	/*
	propriété :  PRIORITY (Array) Les degrés de priorité sous forme de chaines
	propriété :  FATAL (Number) Le code d'une erreur fatale
	propriété :  ERROR (Number) Le code d'une erreur
	propriété :  WARN (Number) Le code d'un avertissement
	propriété :  INFO (Number) Le code d'une information
	propriété :  DEBUG (Number) Le code d'un bug
	*/
	public static var PRIORITY:Array = new Array("FATAL",
												 "ERROR",
												 "WARN",
												 "INFO",
												 "DEBUG");	
	public static var FATAL:Number = 0; 
	public static var ERROR:Number = 1;
	public static var WARN:Number = 2;
	public static var INFO:Number = 3;
	public static var DEBUG:Number = 4;
	
	private var _messg:String;
	private var _fonction:String;
	private var _priorite:Number;
	private var _date:Date;
	
	
	/*
	@method DError.DError()
	entrée :  m (String) le message d'erreur
	entrée :  f (String) la fonction bugée
	entrée :  p (Number) la priorité de l'erreur
	*/
	public function DError (m:String,f:String,p:Number)
	{
		_messg = m;
		_fonction = f;
		_priorite = (p != undefined || !isNaN(p) || p != null) ? p : 1;
		_date = new Date();
	}
	
	
	/*
	sortie :  String L'erreur en une chaine
	*/
	public function toString():String
	{
		return "["+PRIORITY[_priorite]+"] error occurs in '"+_fonction+"' at "+_date+" : "+_messg;
	}
	
	
	
	/*
	propriété :  msg (String) read-only Le texte de l'erreur
	propriété :  func (String) read-only La fonction dans laquelle s'est produit l'erreur
	propriété :  priority (Number) read-only Le degré de priorité de l'erreur
	propriété :  date (Date) read-only un objet Date crée au moment de l'erreur
	*/
	public function get msg ():String
	{
		return _messg;
	}
	
	
	public function get func ():String
	{
		return _fonction;
	}
	
	
	public function get priority ():Number
	{
		return _priorite;
	}
	
	
	public function get date ():Date
	{
		return _date;
	}
}